#include<bits/stdc++.h>
using namespace std;
using ll = long long;
#define sz(x) (int)(x).size()

struct state {
	string want, have;
	int at=-1;
	char pass='-';
	vector<int> vis;
	vector<pair<string,int>> ops;
	
	state(string a, string b) {
		want=a;
		have=b;
		vis.assign(a.size(), 0);
	}
	
	int unsat() {
		for(int i=0;i<sz(want);++i) {
			if(want[i]!='-' && want[i]!=have[i]) {
				return i;
			}
		}
		return -1;
	}
	
	bool valid() {
		return unsat()==-1;
	}
	
	void drive(int x) {
		assert(!vis[x]);
		at=x;
		vis[x]=1;
		ops.emplace_back("DRIVE", x);
	}
	
	void pickup() {
		assert(at!=-1 && have[at]!='-' && pass=='-');
		pass=have[at];
		have[at]='-';
		ops.emplace_back("PICKUP", -1);
	}
	
	void dropoff() {
		assert(pass!='-');
		assert(at!=-1);
		assert(want[at]==pass);
		
		have[at]=pass;
		pass='-';
		ops.emplace_back("DROPOFF", -1);
	}
	
	int find(char a, char b) {
		for(int i=0;i<sz(want);++i){
			if(want[i]==a && have[i]==b) {
				assert(!vis[i]);
				return i; 
			}
		}
		return -1;
	}	
	
	void debug() {
		#ifdef LOCAL
		cerr<<"state"<<at<<"("<<pass<<"):\n"<<want<<"\n"<<have<<"\n\n";
		#endif
	}
};

char other(char c) {
	if(c=='C') return 'M';
	return 'C';
}

int main() {
	int n;
	cin>>n;
	string a,b;
	cin>>a>>b;
	
	for(char elso:{'C', 'M'}) {
		state st(a,b);
		if(st.find('-', elso)!=-1) {
			int where=st.find('-', elso);
			st.drive(where);
			st.pickup();
			st.debug();
			while(!st.valid()) {
				st.debug();
				if(st.pass!='-') {
					int akt=st.find(st.pass, other(st.pass));
					if(akt!=-1) {
						st.drive(akt);
						st.ops.emplace_back("DROPOFF", -1);
						st.ops.emplace_back("PICKUP", -1);
						swap(st.have[akt], st.pass);
					}else {
						akt=st.find(st.pass, '-');
						if(akt==-1) {
							if(!st.ops.empty() && st.ops.back().first=="PICKUP") {
								st.ops.pop_back();
							}else {
								st.ops.emplace_back("DROPOFF", -1);
							}
							st.pass='-';
							continue ;
						}
						st.drive(akt);
						st.dropoff();
					}
				}else {
					assert(st.unsat()!=-1);
					char kellChar=st.want[st.unsat()];
//					cerr<<kellChar<<"\n";
					int hol=st.find('-', kellChar);
					st.drive(hol);
					st.pickup();
				}
			}
			if(st.valid()) {
				cout<<st.ops.size()<<"\n";
				for(auto &[name, cnt]:st.ops) {
					cout<<name;
					if(name=="DRIVE") cout<<" "<<cnt+1;
					cout<<"\n";
				}
				return 0;
			}
			
		} 
	}
	state st(a,b);
	if(st.valid()) {
		cout<<"0\n";
		return 0;
	}
	assert(0);
	return 0;
	
}
